/*
 * Author:	George Ang
 * Create data:	2007-02-10 02:09
 */

#include <unistd.h>
#include <signal.h>
#include <iostream> 
#include "DHTTracker.h"
//#include "TCPTracker.h"
//#include "UDPTracker.h"
#include "utils.h"
#include "log.h"


void* dhttrackerThreadFunc(void* param)
{
	sigset_t sigset;
	sigemptyset(&sigset);
	pthread_sigmask(SIG_SETMASK, &sigset, NULL);
		
	CDHTTracker* manager = (CDHTTracker*)param;
	int ret = manager->svc();
	pthread_exit(&ret);
	
	return NULL;
}

CDHTTracker::CDHTTracker()
: _task(NULL)
, _peerCount(0)
, _seedCount(0)
{
}

CDHTTracker::~CDHTTracker()
{
}

void CDHTTracker::setBTTask(IBTTask* task)
{
	_task = task;
}

IBTTask* CDHTTracker::getBTTask()
{
	return _task;
}

bool CDHTTracker::start()
{
	LOG_INFO("TrackerManager starting");
	
	_peerCount = 0;
	_seedCount = 0;
	
	createTrackers();
	
	_toExit = false;
	pthread_create(&_thrHandle, NULL, dhttrackerThreadFunc, this);	
	
	LOG_INFO("TrackerManager started");
	return true;
}

void CDHTTracker::stop()
{
	LOG_INFO("TrackerManager stopping");
	
	_toExit = true;
	
	stopTrackers();
	
	if(_thrHandle != 0)
	{
		pthread_join(_thrHandle, NULL);
		_thrHandle = 0;
	}	
	
	destroyTrackers();
	
	LOG_INFO("TrackerManager stopped");
}

void CDHTTracker::createTrackers()
{/*
	for(unsigned int i=0; i<_task->getTorrentFile()->getAnnounceCount(); ++i)
	{
		ITracker* tracker = NULL;
		const char* trackerUrl = _task->getTorrentFile()->getAnnounce(i);
		std::string protocol = getUrlProtocol(trackerUrl);
		
		LOG_DEBUG("Tracker URL = "<<trackerUrl);
		
		if(protocol == "http"
			|| protocol == "HTTP")
		{
			tracker = new CTCPTracker();
		}
		
		if(protocol == "udp"
			|| protocol == "UDP")
		{
			tracker = new CUDPTracker();
		}		
		
		if(tracker != NULL)
		{
			tracker->setUrl(trackerUrl);
			tracker->setTrackerManager(this);
		}		
	}
	*/
}

void CDHTTracker::stopTrackers()
{
}

void CDHTTracker::destroyTrackers()
{
}

int CDHTTracker::svc()
{
	for(; !_toExit; )
	{
	    /*
		TTrackerList::iterator iter = _trackerList.begin();
		for(; iter!=_trackerList.end(); ++iter)
		{	
			if(_toExit)
			{
				break;
			}
			
			ITracker* tracker = *iter;
			
			if(tracker->getPeerCount() > _peerCount)
			{
				_peerCount = tracker->getPeerCount();
			}
			
			if(tracker->getSeedCount() > _seedCount)
			{
				_seedCount = tracker->getSeedCount();
			}
						
			if(GetTickCount() < tracker->getNextUpdateTick())
			{
				continue;				
			}
			
			tracker->update();
			
			TTrackerState state = tracker->getState();
			if(state == TS_OK)
			{
			}
		}
		
			*/
		usleep(100*1000);
	}
	
	return 0;
}

unsigned int CDHTTracker::getSeedCount()
{
	return _seedCount;
}

unsigned int CDHTTracker::getPeerCount()
{
	return _peerCount;
}
