/*
 * Author:	George Ang
 * Create data:	2007-02-11 23:23
 */
 
#ifndef UDPLISTENER_H_
#define UDPLISTENER_H_

#include "BitStorm.h"
#include "Socket.h"
#include <boost/thread/mutex.hpp>

class CDHTListener;

class CUDPListener :
	public IPeerAcceptor,
	public CSocket	
{
public:
	CUDPListener();
	virtual ~CUDPListener();
private:
	IBTTask* _task;
	unsigned short _port;	
	unsigned int _natTimerID;
	CDHTListener *m_listener;
	boost::mutex m_mutex;
public:	
 	void setBTTask(IBTTask* task);
	IBTTask* getBTTask();		
	
	bool start();
	void stop();		
	unsigned short getPort();
	void setDHTListener(CDHTListener *);
	
	int handleRead();
	int handleWrite();
	void handleClose();		

	int sendto(const char* buf, size_t len, std::string const& destip, const int destport);
	int sendto(const char* buf, size_t len, uint32_t destip, int destport);
};

#endif /*UDPLISTENER_H_*/
