/*
 * Author:	gxc
 * Create data:	2004-03-09 20:09
 */

#ifndef _BDICT_H_
#define _BDICT_H_

#include <iostream>
#include <string>
#include <map>
#include "bobject.h"
#include "bstring.h"
#include "binteger.h"

class CBDict:public CBObject
{
public:
	CBDict(void)
		:CBObject(4)
		{};
	~CBDict(void)
	{
		clear();
	};

	typedef std::map<std::string,CBObject*> CONTAINER;
private:
	CONTAINER m_value;
	void clear()
	{
		while(!m_value.empty())
		{
			delete (*(m_value.begin())).second;
			m_value.erase(m_value.begin());
		}
	};
public:
	unsigned int getCount(void)
	{
		return m_value.size();
	};
	
	CBObject* getValue(const char* key)
	{
		CONTAINER::iterator iter=m_value.find(key);
		if(iter!=m_value.end())
		{
			return (*iter).second;
		}
		else
		{
			return NULL;
		}
	};
	
	void append(const std::string key, CBObject *value)
	{
		CONTAINER::iterator iter=m_value.find(key);
		if(iter != m_value.end())
		{
			delete (*iter).second;
		}
		(*iter).second=value;

	}

	void append(const std::string key, const int64_t value)
	{
		append(key, new CBInteger(value));

	}

	void append(const std::string key, const std::string value)
	{
		append(key, new CBString(value));

	}

	CBObject* getValue(unsigned int index)
	{
		if(index<m_value.size())
		{
			CONTAINER::iterator iter=m_value.begin();
			for(unsigned int i=0;i<index;++i)
			{
				iter++;
			}	
			
			return iter->second;
		}
		else
		{
			return NULL;
		}
	};
	
	const char* getKey(unsigned int index)
	{
		if(index<m_value.size())
		{
			CONTAINER::iterator iter=m_value.begin();
			for(unsigned int i=0;i<index;++i)
			{
				iter++;
			}
			
			return iter->first.c_str();
		}
		else
		{
			return NULL;
		}	
	}
	
	int parse(const char* buf,unsigned long bufLen);
	
	CBObject* dup()
	{
		CBDict *newDict = new CBDict();
		CONTAINER::iterator iter = m_value.begin();
		for(;iter != m_value.end(); ++iter)
		{
			newDict->append(iter->first, iter->second->dup());
		}
		return newDict;
	}
	
	void get_bestr(std::string& str)
	{
		char buf[128];
		
		str+="d";
		CONTAINER::iterator iter=m_value.begin();
		for(;iter!=m_value.end();++iter)
		{
			memset(buf,0,sizeof(buf));
			sprintf(buf,"%u",iter->first.length());
			str+=buf;
			str+=":";
			str+=iter->first;
			
			iter->second->get_bestr(str);			
		}
		str+="e";
	}
};

#endif

