/*
 * Author:	gxcoo
 * Create Date:	2004-03-06 14:41
 */

#ifndef _BINTEGER_H_
#define _BINTEGER_H_

#include <string.h>
#include <string>
#include <stdio.h>
#include "bobject.h"

class CBInteger:public CBObject
{
public:
	CBInteger(void)
		:CBObject(1)
		,m_value(0)
		{};
	CBInteger(int64_t value)
		:CBObject(1)
		,m_value(value)
	{};
	CBInteger(int32_t value)
		:CBObject(1)
		,m_value(value)
	{};	
	~CBInteger(void){};


private:
	int64_t m_value;
public:
	int64_t getValue(void)
	{
		return m_value;
	};

	int64_t assign(int64_t value)
	{
		m_value = value;
		return m_value;
	}
	int64_t assign(int32_t value)
	{
		m_value = int64_t(value);
		return m_value;
	}

	int64_t operator = (int64_t value)
	{
		return assign(value);
	}
	int64_t operator = (int32_t value)
	{
		return assign(value);
	}

	CBObject *dup()
	{
		return new CBInteger(m_value);
	}

	int parse(const char* buf,unsigned long bufLen)
	{
		int result=-1;
		
		if(buf[0]=='i')
		{
			unsigned long i=1;
			while(buf[i]!='e' && i<bufLen)
			{
				++i;
			}
				
			if(buf[i]=='e')
			{
				char* temp=new char[i];
				if(temp!=NULL)
				{
					strncpy(temp,&buf[1],i-1);
					temp[i-1]='\0';
					m_value=atoll(temp);
					delete temp;
					result=i+1;
				}
			}
		}
		return result;
	};
	
	void get_bestr(std::string& str)
	{
		char buf[1024];
		memset(buf,0,sizeof(buf));
		sprintf(buf,"i%llde",m_value);
		str+=buf;
	};	
};

#endif
