/*
Copyritht (C)2006 George Ang <gnap.an [AT] gmail.com> 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include<inttypes.h>
#include <string>
#include <kademlia/utils/debug.hpp>

#ifndef KADLISTENER_HPP
#define KADLISTENER_HPP

namespace kademlia
{

	template<typename _uintX> class contact;

	template<typename _uintX, class debugger = debug>
	class kad_listener {
		public:
			kad_listener() {};
			virtual ~kad_listener() {} ;
			typedef _uintX uint_type;
			typedef contact<uint_type> contact_type;
			virtual bool  add_contact (
					contact_type *contact_ptr,
					bool keep = false) = 0;

			virtual bool is_connected() = 0;
			
			virtual void send_HELLO(std::string const& client, int port) = 0;
			virtual void send_HELLO(contact_type *contact_ptr) = 0;

			virtual void send_BOOTSTRAP_REQUEST(contact_type *contact_ptr) = 0;

			virtual void send_NODE_LOOKUP_REQUEST(
					const uint_type& target_id,
					const uint_type& session_id,
					contact_type *contact_ptr) = 0;

			virtual void send_STORE_VALUE(
					const uint_type& target_id,
					const std::string& content,
					const std::string& arguments,
					contact_type* contact_ptr) = 0;

			virtual void send_SEARCH_REQUEST(
					const uint_type& target_key,
					const uint_type& sessioin_id,
					const std::string& arguments,
					contact_type* contact_ptr) = 0;

			//Incoming protocol data processing, NOT HAVE TO be implemented. 
//			virtual void process_recv_packet(uint8_t* buf, int len, std::string client, std::string port);
/*			virtual void process_BOOTSTRAP_REQUEST (contact_type* contact_ptr);
			virtual void process_BOOTSTRAP_REPLY (const char* protocol_data, size_t len, contact_type* contact_ptr) = 0;

			virtual void process_HELLO_REQUEST(const char* protocol_data, size_t len, contact_type* contact_ptr) = 0;
			virtual void process_HELLO_REPLY(const char* protocol_data, size_t len, contact_type* contact_ptr) = 0;

			virtual void process_NODE_LOOKUP_REQUEST(const char* protocol_data, size_t len, contact_type* contact_ptr) = 0;
			virtual void process_NODE_LOOKUP_REPLY(const char* protocol_data, size_t len, contact_type* contatct_ptr) = 0;

			virtual void process_SEARCH_REQUEST(const char* protocol_data, size_t len, contact_type* contact_ptr) = 0;
			virtual void process_SEARCH_REPLY(const char* protocol_data, size_t len, contact_type* contact_ptr) = 0;

			virtual void process_PUBLISH_REQUEST(const char* protocol_data, size_t len, contact_type* contact_ptr) = 0;
			virtual void process_PUBLISH_REPLY(const char* protocol_data, size_t len, contact_type* contact_ptr) = 0;
			*/
	};
}

#endif //KADLISTENER_HPP

