/*
Copyright (C)2006 George Ang (gnap.an AT gmail.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 


#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#ifndef _DEBUG_HPP
#define _DEBUG_HPP

#define NORMAL		0x0000
#define NETWORK		0x0001
#define ROUTETABLE	0x0002
#define TIMER		0x0004
#define PROCESS		0x0008
#define SESSION		0x0010
#define RUNTIME		0x0020
#define STORAGE		0x0040
#define TEMP		0x0080


namespace kademlia{
	class debug{
		public:
			static void send(int, const char *, ...);
			static void set_level(const int);
		private:
			static boost::mutex m_mutex;
			static int m_level;
	};
}

#endif //_DEBUG_HPP
