/*
Copyright (C)2006 George Ang (gnap.an AT gmail.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 



#include <iostream>
#include <stdarg.h>
#include "dhtdebug.h"
#ifdef _DEBUG
using namespace log4cxx;

LoggerPtr dhtdebug::logger(Logger::getLogger("Anulus"));
#endif
void dhtdebug::send(int level, const char *fmt, ...)
{
	boost::mutex::scoped_lock lock(m_mutex);
	if(!(level & m_level))
		return;
	char buf[5120];
	char *timeptr;
	va_list args;	

	va_start(args, fmt);
	vsnprintf(buf, sizeof(buf), fmt, args);
	va_end(args);

	const time_t now = time(NULL);

	timeptr = ctime(&now);

	timeptr[strlen(timeptr) - 1] = ' ';

#ifdef _DEBUG
	LOG4CXX_DEBUG(logger, buf);
#endif        
}

void dhtdebug::set_level(int level)
{
	m_level = level;
}

int dhtdebug::m_level = 127;
boost::mutex dhtdebug::m_mutex;

